|
@@ -0,0 +1,134 @@
|
|
1
|
+#!/bin/bash
|
|
2
|
+#
|
|
3
|
+# .---. . .
|
|
4
|
+# | | |
|
|
5
|
+# |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
|
|
6
|
+# | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
|
|
7
|
+# ' ' --' --' -' - -' ' ' -' -' -' ' - --'
|
|
8
|
+#
|
|
9
|
+# Freedom in the Cloud
|
|
10
|
+#
|
|
11
|
+# Useful git functions
|
|
12
|
+#
|
|
13
|
+# License
|
|
14
|
+# =======
|
|
15
|
+#
|
|
16
|
+# Copyright (C) 2014-2016 Bob Mottram <bob@robotics.uk.to>
|
|
17
|
+#
|
|
18
|
+# This program is free software: you can redistribute it and/or modify
|
|
19
|
+# it under the terms of the GNU Affero General Public License as published by
|
|
20
|
+# the Free Software Foundation, either version 3 of the License, or
|
|
21
|
+# (at your option) any later version.
|
|
22
|
+#
|
|
23
|
+# This program is distributed in the hope that it will be useful,
|
|
24
|
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
|
|
25
|
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
|
|
26
|
+# GNU Affero General Public License for more details.
|
|
27
|
+#
|
|
28
|
+# You should have received a copy of the GNU Affero General Public License
|
|
29
|
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
|
|
30
|
+
|
|
31
|
+NO_OF_ARGS=$#
|
|
32
|
+
|
|
33
|
+PROJECT_NAME='freedombone'
|
|
34
|
+
|
|
35
|
+export TEXTDOMAIN=$PROJECT_NAME-utils-git
|
|
36
|
+export TEXTDOMAINDIR="/usr/share/locale"
|
|
37
|
+
|
|
38
|
+# An optional configuration file which overrides some of these variables
|
|
39
|
+CONFIGURATION_FILE="${PROJECT_NAME}.cfg"
|
|
40
|
+
|
|
41
|
+if [ -f ~/${PROJECT_NAME}.cfg ]; then
|
|
42
|
+ CONFIGURATION_FILE=~/${PROJECT_NAME}.cfg
|
|
43
|
+fi
|
|
44
|
+
|
|
45
|
+# friends repo mirrors
|
|
46
|
+FRIENDS_MIRRORS_SERVER=
|
|
47
|
+FRIENDS_MIRRORS_PASSWORD=
|
|
48
|
+FRIENDS_MIRRORS_SSH_PORT=
|
|
49
|
+
|
|
50
|
+function get_friends_servers {
|
|
51
|
+ if [ -f $CONFIGURATION_FILE ]; then
|
|
52
|
+ if grep -q "FRIENDS_MIRRORS_SERVER" $CONFIGURATION_FILE; then
|
|
53
|
+ FRIENDS_MIRRORS_SERVER=$(grep "FRIENDS_MIRRORS_SERVER" $CONFIGURATION_FILE | awk -F '=' '{print $2}')
|
|
54
|
+ fi
|
|
55
|
+ if grep -q "FRIENDS_MIRRORS_PASSWORD" $CONFIGURATION_FILE; then
|
|
56
|
+ FRIENDS_MIRRORS_PASSWORD=$(grep "FRIENDS_MIRRORS_PASSWORD" $CONFIGURATION_FILE | awk -F '=' '{print $2}')
|
|
57
|
+ fi
|
|
58
|
+ if grep -q "FRIENDS_MIRRORS_SSH_PORT" $CONFIGURATION_FILE; then
|
|
59
|
+ FRIENDS_MIRRORS_SSH_PORT=$(grep "FRIENDS_MIRRORS_SSH_PORT" $CONFIGURATION_FILE | awk -F '=' '{print $2}')
|
|
60
|
+ fi
|
|
61
|
+ fi
|
|
62
|
+
|
|
63
|
+ if [ ! $FRIENDS_MIRRORS_SERVER ]; then
|
|
64
|
+ echo "1"
|
|
65
|
+ return
|
|
66
|
+ fi
|
|
67
|
+ if [ ${#FRIENDS_MIRRORS_SERVER} -lt 2 ]; then
|
|
68
|
+ echo "1"
|
|
69
|
+ return
|
|
70
|
+ fi
|
|
71
|
+ echo "0"
|
|
72
|
+}
|
|
73
|
+
|
|
74
|
+function git_clone {
|
|
75
|
+ repo_url="$1"
|
|
76
|
+ destination_dir="$2"
|
|
77
|
+
|
|
78
|
+ if [[ "$repo_url" == "ssh:"* ]]; then
|
|
79
|
+ retval=$(get_friends_servers)
|
|
80
|
+ if [[ $retval == "0" ]]; then
|
|
81
|
+ if [ "${FRIENDS_MIRRORS_SERVER}" ]; then
|
|
82
|
+ if [ ${#FRIENDS_MIRRORS_SERVER} -gt 2 ]; then
|
|
83
|
+ if [ "$FRIENDS_MIRRORS_PASSWORD" ]; then
|
|
84
|
+ if [ ${#FRIENDS_MIRRORS_PASSWORD} -gt 2 ]; then
|
|
85
|
+ echo "sshpass -p \"$FRIENDS_MIRRORS_PASSWORD\" git clone $repo_url $destination_dir"
|
|
86
|
+ sshpass -p "$FRIENDS_MIRRORS_PASSWORD" git clone "$repo_url" "$destination_dir"
|
|
87
|
+ return
|
|
88
|
+ fi
|
|
89
|
+ fi
|
|
90
|
+ fi
|
|
91
|
+ fi
|
|
92
|
+ fi
|
|
93
|
+ fi
|
|
94
|
+ echo "git clone $repo_url $destination_dir"
|
|
95
|
+ git clone "$repo_url" "$destination_dir"
|
|
96
|
+}
|
|
97
|
+
|
|
98
|
+function git_pull {
|
|
99
|
+ if [ ! $1 ]; then
|
|
100
|
+ echo $'git_pull no repo specified'
|
|
101
|
+ fi
|
|
102
|
+
|
|
103
|
+ git stash
|
|
104
|
+ git remote set-url origin $1
|
|
105
|
+ git checkout master
|
|
106
|
+ get_friends_servers
|
|
107
|
+ if [ "${FRIENDS_MIRRORS_SERVER}" ]; then
|
|
108
|
+ if [ ${#FRIENDS_MIRRORS_SERVER} -gt 2 ]; then
|
|
109
|
+ if [ "$FRIENDS_MIRRORS_PASSWORD" ]; then
|
|
110
|
+ if [ ${#FRIENDS_MIRRORS_PASSWORD} -gt 2 ]; then
|
|
111
|
+ sshpass -p "$FRIENDS_MIRRORS_PASSWORD" git pull
|
|
112
|
+ if [ $2 ]; then
|
|
113
|
+ git checkout $2 -b $2
|
|
114
|
+ fi
|
|
115
|
+ return
|
|
116
|
+ fi
|
|
117
|
+ fi
|
|
118
|
+ fi
|
|
119
|
+ fi
|
|
120
|
+ git pull
|
|
121
|
+
|
|
122
|
+ if [ $2 ]; then
|
|
123
|
+ # delete any existing branch
|
|
124
|
+ git branch -D $2
|
|
125
|
+ # check out the new branch
|
|
126
|
+ git checkout $2 -b $2
|
|
127
|
+ if [ ! "$?" = "0" ]; then
|
|
128
|
+ echo $"Unable to checkout $1 $2"
|
|
129
|
+ exit 72357
|
|
130
|
+ fi
|
|
131
|
+ fi
|
|
132
|
+}
|
|
133
|
+
|
|
134
|
+# NOTE: deliberately no exit 0
|